Imports GrapeCity.ActiveReports.Document.Section
Imports GrapeCity.ActiveReports.SectionReportModel

Imports System.IO

Public Class rptTester
    Private _sw As New Stopwatch

    Private _GrandTotal As Double = 0
    Private _GroupTotal As Double = 0
    Private _ParTotal As Double = 0

    Private _RecType As PrintRecordType
    Private _Paragraaf As String = ""
    Private _OwnerForm As Object = Nothing
    Private _MainForm As Object = Nothing
    Private _Offnr As String = ""

    Private _PrintLogo As Boolean = True
    Private _PrintDatum As Boolean = True
    Private _PrintArtikelNr As Boolean = True
    Private _PrintOnderbouwing As Boolean = True
    Private _PrintParagraafTotalen As Boolean = True
    Private _PrintHoofdstukTotalen As Boolean = True
    Private _PrintRegelTotalen As Boolean = True
    Private _PrintPrijs As Boolean = True
    Private _PrintGrootTotaal As Boolean = True
    Private _PrintBtw As Boolean = True
    Private _PrintNullen As Boolean = True
    Private _PrintOverzichtZonderCalculatie As Boolean = False
    Private _PrintAantal As Boolean = True
    Private _PrintTextblock As Boolean = False
    Private _PrintBedragInline As Boolean = False

    Private _BmpLogo As Bitmap = Nothing
    Private _BmpLogo2 As Bitmap = Nothing
    Private _BmpLogoVolg As Bitmap = Nothing
    Private _BmpLogoVolg2 As Bitmap = Nothing
    Private _DocTitel As String = ""
    Private _PrintStatus As Boolean = False
    Private _BodyTextForeColor As Color = Color.Black
    Private _ColTextForeColor As Color = Color.Black
    Private _MarkColor As Color = Color.FromArgb(157, 206, 255)
    Private _BodyTextMargin As Single = 0
    Private _NegativeRed As Boolean = False
    Private _MarkeerCols As Collection
    Private _StaartMarkeerCols As Collection

    Private _lstAdditionalPages As New List(Of Page)

    Public Enum PrintRecordType
        GroepStart
        Header
        KostenPost
        LegeRegel
        TekstRegel
        SubtotaalRegel
        TotaalRegel
        GrootTotaalRegel
        GroepEinde
        PaginaEinde
    End Enum

    Public WriteOnly Property PrintLogo() As Boolean
        Set(value As Boolean)
            _PrintLogo = value
        End Set
    End Property

    Public WriteOnly Property DocType() As String
        Set(value As String)
            _DocTitel = value
        End Set
    End Property

    Public WriteOnly Property PrintDatum() As Boolean
        Set(value As Boolean)
            _PrintDatum = value
        End Set
    End Property

    Public WriteOnly Property PrintArtikelNr() As Boolean
        Set(value As Boolean)
            _PrintArtikelNr = value
        End Set
    End Property

    Public WriteOnly Property PrintRegelTotalen() As Boolean
        Set(value As Boolean)
            _PrintRegelTotalen = value
        End Set
    End Property

    Public WriteOnly Property PrintParagraafTotalen() As Boolean
        Set(value As Boolean)
            _PrintParagraafTotalen = value
        End Set
    End Property

    Public WriteOnly Property PrintHoofdstukTotalen() As Boolean
        Set(value As Boolean)
            _PrintHoofdstukTotalen = value
        End Set
    End Property

    Public WriteOnly Property PrintBtw() As Boolean
        Set(value As Boolean)
            _PrintBtw = value
        End Set
    End Property

    Public WriteOnly Property PrintGrootTotaal() As Boolean
        Set(value As Boolean)
            _PrintGrootTotaal = value
        End Set
    End Property

    Public WriteOnly Property PrintNullen() As Boolean
        Set(value As Boolean)
            _PrintNullen = value
        End Set
    End Property

    Public WriteOnly Property PrintDisclaimer() As Boolean
        Set(value As Boolean)
            'lblDisclaimer.Visible = value
        End Set
    End Property

    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.

        _sw.Start()

        Console.WriteLine("New > Totaal verstreken: " & _sw.ElapsedMilliseconds & " milliseconden")
    End Sub

    Private Sub pSetValutaSign()
        Dim teken As String = "$"
        If teken = "" Then Return
        Try
            lblTotaalExclEuro.Text = teken
            lblBtwHoogEuro.Text = teken
            lblBtwLaagEuro.Text = teken
            lblBtwVerlegdEuro.Text = teken
            lblTotaalInclEuro.Text = teken
        Catch ex As Exception
        End Try
    End Sub

    Private Sub pSetFontProperties()
        '
        '
    End Sub

    Private Sub pSetColPositions()
        If Not _PrintArtikelNr Then
            If Not _PrintTextblock Then
                lblGhArtikel.Visible = False
                txtArtNr.Visible = False
                lblGhAantal.Left -= lblGhArtikel.Width
                lblGhEenheid.Left -= lblGhArtikel.Width
                lblGhOmschrijving.Left -= lblGhArtikel.Width
                txtOmschrijving.Width += lblGhArtikel.Width
            Else
                lblGhArtikel.Visible = False
                txtArtNr.Visible = False
            End If
            txtAantal.Left = lblGhAantal.Left
            txtEenheid.Left = lblGhEenheid.Left
            txtOmschrijving.Left = lblGhOmschrijving.Left
        End If
        If Not _PrintAantal Then
            lblGhAantal.Visible = False
            lblGhEenheid.Visible = False
            txtAantal.Visible = False
            txtEenheid.Visible = False
            Dim verschil As Single = txtAantal.Width + txtEenheid.Width
            lblGhOmschrijving.Left -= verschil
            txtOmschrijving.Left -= verschil
            txtOmschrijving.Width += verschil
        End If
        lblGhBedrag.Visible = _PrintParagraafTotalen OrElse _PrintHoofdstukTotalen
        LblGhSubTotaal.Visible = _PrintRegelTotalen
        lblGhPrijs.Visible = _PrintPrijs
    End Sub

    Private Sub pSetGroupHeaderLines()
        ghLine1.Visible = False
        ghLine2.Visible = False
        gfLine1.Visible = False
    End Sub

    Private Sub pPrintUserLayout()
        Dim i As Integer = 1
        Dim pagecount As Integer = Document.Pages.Count
        For Each pagina As Page In Document.Pages
            If i > 1 Then
                'pPrintVolgBlad(pagina, i, pagecount)
            Else
                'pPrintBlad1(pagina, pagecount)
            End If
            i += 1
        Next
        ' evt voorwaarden
        For Each pagina As Page In _lstAdditionalPages
            Document.Pages.Add(pagina)
        Next
    End Sub

    Private Sub rpt_DataInitialize(sender As Object, e As EventArgs) Handles Me.DataInitialize
        Fields.Add("Subtotaal")
        Fields.Add("GroepTotaal")
        Fields.Add("NieuwePagina")
        Console.WriteLine("DataInitialize > Totaal verstreken: " & _sw.ElapsedMilliseconds & " milliseconden")
    End Sub

    Private Sub rpt_FetchData(sender As Object, eArgs As FetchEventArgs) Handles Me.FetchData
        Try
            If DataSource Is Nothing Then Return
            _RecType = PrintRecordType.KostenPost

            If Not eArgs.EOF Then
                lblStreepje1.Visible = False
                lblStreepje2.Visible = False
                lblStreepje3.Visible = False
                LineParagraafTotaal.Visible = False
                rptDetails.Visible = False
                rptDetails.NewPage = NewPage.None
                gfHoofdstuk.Visible = _PrintHoofdstukTotalen
                If _PrintTextblock Then pResetTextBlock()

                Dim rectype As PrintRecordType = Fields("RecordType").Value
                Dim aantal As Double = Fields("Aantal").Value
                Dim ehprijs As Double = Fields("EenheidsPrijs").Value
                Dim prijs As Double = Fields("Prijs").Value
                Dim subtotal As Double = Fields("Bedrag").Value

                Fields("Aantal").Value = If(_PrintAantal, pGetFieldValue(aantal), DBNull.Value)
                Fields("EenheidsPrijs").Value = If(_PrintPrijs, pGetFieldValue(ehprijs), DBNull.Value)

                Select Case rectype
                    Case PrintRecordType.KostenPost
                        rptDetails.Visible = True
                        If _PrintRegelTotalen Then
                            If _PrintParagraafTotalen Then ' wisselen van kolom
                                Fields("Subtotaal").Value = pGetFieldValue(subtotal)
                                Fields("Bedrag").Value = DBNull.Value
                            Else
                                Fields("Subtotaal").Value = DBNull.Value
                                Fields("Bedrag").Value = pGetFieldValue(subtotal)
                            End If
                        Else
                            Fields("Subtotaal").Value = DBNull.Value
                            Fields("Bedrag").Value = DBNull.Value
                        End If
                        If aantal = 0 AndAlso ehprijs = 0 AndAlso _PrintPrijs Then ' ivm opgaaf evt meerprijs (23-04-2021)
                            Fields("EenheidsPrijs").Value = pGetFieldValue(prijs)
                        End If
                        _ParTotal += subtotal
                        _GroupTotal += subtotal
                        _GrandTotal += subtotal
                        Fields("GroepTotaal").Value = pGetFieldValue(_GroupTotal)
                        LineGroepTotaal.Visible = _GroupTotal <> 0 AndAlso _PrintHoofdstukTotalen

                    Case PrintRecordType.GroepStart
                        'pResetTextBlock()
                        txtGroepsOmschrijving.Text = Fields("Omschrijving").Value
                        _GroupTotal = 0
                        _ParTotal = 0
                        Fields("GroepTotaal").Value = DBNull.Value ' reset

                    Case PrintRecordType.Header
                        _ParTotal = 0 ' reset
                        rptDetails.Visible = True
                        Fields("Subtotaal").Value = DBNull.Value
                        Dim bedrag As Double = Fields("Bedrag").Value
                        Fields("Bedrag").Value = pGetFieldValue(bedrag)
                        _GroupTotal += bedrag
                        Fields("GroepTotaal").Value = pGetFieldValue(_GroupTotal)
                        Dim iselement As Boolean = Fields("IsElement").Value
                        If Not iselement Then
                            If _PrintParagraafTotalen AndAlso _PrintRegelTotalen Then
                                Fields("Bedrag").Value = DBNull.Value
                            End If
                            If Not _PrintOnderbouwing Then
                                _GroupTotal -= bedrag
                            End If
                        End If

                        Dim onMaxLevel As Boolean = Fields("OnMaxLevel").Value
                        If Not _PrintBedragInline Then
                            If Not _PrintRegelTotalen Then
                                Fields("Bedrag").Value = DBNull.Value
                            End If
                        Else
                            If _PrintOnderbouwing Then
                                If Not onMaxLevel Then
                                    _GroupTotal -= bedrag
                                End If
                            End If
                        End If

                        If Not onMaxLevel Then
                            If Not _PrintOnderbouwing AndAlso iselement Then
                                _GrandTotal += bedrag
                            End If
                        Else
                            _ParTotal = bedrag  ' 19-01-2017
                            _GrandTotal += bedrag
                            If _PrintParagraafTotalen OrElse _PrintRegelTotalen Then ' 19-01-2017
                                Fields("Bedrag").Value = pGetFieldValue(_ParTotal)
                            End If
                        End If
                        ' ResetTextBlock
                        If Me.rptDetails.Visible AndAlso _PrintTextblock Then
                            Dim tekstblok As String = Fields("Tekst").Value
                            Dim filenaam As String = Fields("Bestandsnaam").Value
                            If tekstblok <> "" OrElse filenaam <> "" Then
                                ghTekstblok.Visible = True
                                txtBeschrijving.Text = tekstblok
                                txtTitel.Text = Fields("Titel").Value
                                If File.Exists(filenaam) Then
                                    imgProduct.Image = New Bitmap(filenaam)
                                    imgProduct.HyperLink = Fields("Hyperlink").Value
                                    imgProduct.Description = txtTitel.Text
                                    imgProduct.BackColor = Color.Transparent
                                Else
                                    imgProduct.BackColor = Color.WhiteSmoke
                                End If
                            End If
                        End If
                        LineGroepTotaal.Visible = _GroupTotal <> 0 AndAlso _PrintHoofdstukTotalen ' 10-03-2018

                    Case PrintRecordType.TekstRegel, PrintRecordType.LegeRegel
                        rptDetails.Visible = True
                        Fields("Subtotaal").Value = DBNull.Value
                        Fields("Bedrag").Value = DBNull.Value

                    Case PrintRecordType.SubtotaalRegel
                        'pResetTextBlock()
                        rptDetails.Visible = True
                        LineParagraafTotaal.Visible = (_PrintRegelTotalen AndAlso _ParTotal <> 0)
                        Fields("Subtotaal").Value = DBNull.Value
                        Fields("Bedrag").Value = pGetFieldValue(_ParTotal)

                    Case PrintRecordType.PaginaEinde
                        'pResetTextBlock()
                        txtGroepsOmschrijving.Text = Fields("Tekst").Value
                        rptDetails.Visible = True
                        rptDetails.NewPage = NewPage.Before
                        Fields("Subtotaal").Value = DBNull.Value
                        Fields("Bedrag").Value = DBNull.Value

                    Case Else
                        MsgBox("onbekend recordtype: " & _RecType)
                End Select
            End If

        Catch ex As Exception
            If Me.DataSource IsNot Nothing Then Beep()
        End Try
    End Sub

    Private Sub pResetTextBlock()
        ghTekstblok.Visible = False
        txtBeschrijving.Text = ""
        txtTitel.Text = ""
        imgProduct.Image = Nothing
        imgProduct.HyperLink = ""
        imgProduct.Description = ""
        imgProduct.BackColor = Color.WhiteSmoke
        imgProduct.Height = imgProduct.Width
    End Sub

    Private Sub pSetImageHeight(bmp As Bitmap)
        If bmp Is Nothing Then Return
        imgProduct.Height = bmp.Height * imgProduct.Width / bmp.Width
    End Sub

    Private Function pIsNegative(value As Object) As Boolean
        Try
            If value Is DBNull.Value Then Return False
            If CType(value, Double) < 0 Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            Return False
        End Try
    End Function

    Private Function pGetFieldValue(value As Double) As Object
        If value <> 0 Then
            Return value
        Else
            If _PrintNullen Then
                Return 0
            Else
                Return DBNull.Value
            End If
        End If
    End Function

    Private Sub rptCalculatieExtern_PageStart(sender As Object, e As EventArgs) Handles Me.PageStart
        Console.WriteLine("PageStart > Totaal verstreken: " & _sw.ElapsedMilliseconds & " milliseconden")
        Static Nr As Integer = 0
        Dim destRect As RectangleF = Nothing
        Dim offsetX As Integer = 0
        Dim offsetY As Single = 0 'in inch
        Dim tmpPage As Page = sender.CurrentPage

        If _PrintLogo Then
            If tmpPage IsNot Nothing Then
                If Nr = 0 Then
                    'If _BmpLogo2 IsNot Nothing Then
                    '    offsetX = pGetOffset(_A4.Logo2.Uitlijning, _A4.Logo2.Breedte)
                    '    With destRect
                    '        .X = _A4.Logo2.Locatie.X + offsetX
                    '        .Y = _A4.Logo2.Locatie.Y
                    '        .Width = _A4.Logo2.Breedte
                    '        .Height = _BmpLogo2.Height * .Width / _BmpLogo2.Width  
                    '    End With
                    '    tmpPage.DrawImage(_BmpLogo2, destRect.X, destRect.Y, destRect.Width, destRect.Height) 
                    'End If
                Else
                    If _BmpLogoVolg2 IsNot Nothing Then
                        'offsetX = pGetOffset(_A42.Logo2.Uitlijning, _A42.Logo2.Breedte)
                        'With destRect
                        '    .X = _A42.Logo2.Locatie.X + offsetX
                        '    .Y = _A42.Logo2.Locatie.Y
                        '    .Width = _A42.Logo2.Breedte
                        '    .Height = _BmpLogo2.Height * .Width / _BmpLogo2.Width  
                        'End With
                        'tmpPage.DrawImage(_BmpLogo2, destRect.X, destRect.Y, destRect.Width, destRect.Height) 
                    End If
                End If
            End If
        End If
        Nr += 1
    End Sub

    Private Sub rptCalculatieExtern_ReportEnd(sender As Object, e As EventArgs) Handles Me.ReportEnd
        pPrintUserLayout()
        Console.WriteLine("ReportEnd > Totaal verstreken: " & _sw.ElapsedMilliseconds & " milliseconden")
    End Sub

    Private Sub rpt_ReportStart(sender As Object, e As EventArgs) Handles Me.ReportStart
        Line7.Visible = False
        Line8.Visible = False
        PageSettings.Orientation = PageOrientation.Portrait

        _Offnr = "2021.456"
        _PrintOnderbouwing = True
        _PrintPrijs = True
        _PrintStatus = False
        _PrintAantal = True
        _NegativeRed = True
        _PrintTextblock = False
        _PrintBedragInline = False

        pSetFontProperties()
        pSetColPositions()
        pSetGroupHeaderLines()
        pSetValutaSign()
        pSetOutputFormats()

        ' voor- en nalooptekst
        rtfVoorloopTekst.Height = 0
        rptPageHeader.Height = 0
        rptPageFooter.Height = 0
        rtfVoorloopTekst.RTF = ""
        rtfNaloopTekst.RTF = ""

        Dim tmpMap As String = Environment.GetFolderPath(Environment.SpecialFolder.InternetCache)
        If rtfVoorloopTekst.Text.Trim.Length = 0 Then
            ghTekst.Visible = False
        Else
            'If TextObject.HasImages Then 
            '    Dim tmpfile As String = tmpMap & "\voorloop.rtf"
            '    If File.Exists(tmpfile) Then
            '        Dim sb As New Text.StringBuilder()
            '        Try
            '            Using sr As New StreamReader(tmpfile)
            '                Do While Not sr.EndOfStream
            '                    sb.AppendLine(sr.ReadLine)
            '                Loop
            '                sr.Close()
            '                sr.Dispose()
            '            End Using
            '            rtfVoorloopTekst.RTF = sb.ToString
            '        Catch ex As Exception
            '        End Try
            '    End If
            'End If
            ghTekst.Visible = True
        End If
        If rtfNaloopTekst.Text.Trim.Length = 0 Then
            gfTekst.Visible = False
        Else
            Dim tmpfile As String = tmpMap & "\naloop.rtf"
            If File.Exists(tmpfile) Then
                Dim sb As New Text.StringBuilder()
                Try
                    Using sr As New StreamReader(tmpfile)
                        Do While Not sr.EndOfStream
                            sb.AppendLine(sr.ReadLine)
                        Loop
                        sr.Close()
                        sr.Dispose()
                    End Using
                    rtfNaloopTekst.RTF = sb.ToString
                Catch ex As Exception
                End Try
            End If
            gfTekst.Visible = True
        End If
        ghTekstblok.Visible = False
        gfHoofdstuk.Visible = _PrintHoofdstukTotalen
    End Sub

    Private Sub PageHeader_Format(sender As Object, e As EventArgs) Handles rptPageHeader.Format
        Dim pageNr As Integer = txtPagina.Value
        If pageNr > 1 Then
            'rptPageHeader.Height = MmToInch(_A42.HoogteKoptekst)
            'rptPageFooter.Height = MmToInch(_A42.HoogteVoettekst)
        Else
            'rptPageHeader.Height = MmToInch(_A4.HoogteKoptekst)
            'rptPageFooter.Height = MmToInch(_A4.HoogteVoettekst)
        End If
    End Sub

    Private Sub PageFooter_BeforePrint(sender As Object, e As EventArgs) Handles rptPageFooter.BeforePrint
        Dim PageCount As Integer = txtPfPages.Value
        Dim PageNr As Integer = txtPfPage.Value
    End Sub

    Private Sub gfCalculatie_Format(sender As Object, e As EventArgs) Handles gfCalculatie.Format
        If DataSource Is Nothing Then
            gfCalculatie.Visible = False
            Return
        End If
        If _PrintGrootTotaal Then
            gfCalculatie.Visible = True
            If Not _PrintBtw Then
                lblBtwHoog.Visible = False
                lblBtwHoogEuro.Visible = False
                txtBtwHoog.Visible = False
                lblBtwLaag.Visible = False
                lblBtwLaagEuro.Visible = False
                txtBtwLaag.Visible = False
                lblBtwVerlegd.Visible = False
                lblBtwVerlegdEuro.Visible = False
                txtBtwVerlegd.Visible = False
                Line3.Visible = False
                Line4.Visible = False
                lblTotaalIncl.Visible = False
                lblTotaalInclEuro.Visible = False
                txtTotaalInclBtw.Visible = False
            Else
                Dim regelhoogte As Single = txtBtwHoog.Top - txtTotaalexclBtw.Top
                If Not txtBtwVerlegd.Visible Then
                    Line3.Y1 -= regelhoogte
                    Line3.Y2 -= regelhoogte
                    Line4.Y1 -= regelhoogte
                    Line4.Y2 -= regelhoogte
                    lblTotaalIncl.Top -= regelhoogte
                    lblTotaalInclEuro.Top -= regelhoogte
                    txtTotaalInclBtw.Top -= regelhoogte
                    gfCalculatie.Height -= regelhoogte
                End If
                If Not txtBtwLaag.Visible Then
                    Line3.Y1 -= regelhoogte
                    Line3.Y2 -= regelhoogte
                    Line4.Y1 -= regelhoogte
                    Line4.Y2 -= regelhoogte
                    lblTotaalIncl.Top -= regelhoogte
                    lblTotaalInclEuro.Top -= regelhoogte
                    txtTotaalInclBtw.Top -= regelhoogte
                    gfCalculatie.Height -= regelhoogte
                    If txtBtwVerlegd.Visible Then ' schuif een regel omhoog
                        lblBtwVerlegd.Top -= regelhoogte
                        lblBtwVerlegdEuro.Top -= regelhoogte
                        txtBtwVerlegd.Top -= regelhoogte
                    End If
                End If
            End If
            gfCalculatie.AddBookmark("Totalen")
        Else
            gfCalculatie.Visible = False
        End If
    End Sub

    Private Sub gfCalculatie_BeforePrint(sender As Object, e As EventArgs) Handles gfCalculatie.BeforePrint
        If DataSource Is Nothing Then Return
    End Sub

    Private Sub Details_Format(sender As Object, e As EventArgs) Handles rptDetails.Format
        Static fieldColorChanged As Boolean = False
        Try
            GridLine.Y1 = txtOmschrijving.Height - _BodyTextMargin
            GridLine.Y2 = GridLine.Y1

            Dim recType As PrintRecordType = Fields("RecordType").Value
            Dim fntStyle As FontStyle = Fields("LetterType").Value
            Dim fntSize As Single = txtOmschrijving.Font.Size
            Dim fntName As String = txtOmschrijving.Font.Name
            Dim fnt As Font = New Font(fntName, fntSize, fntStyle)
            Dim fntRegular As Font = New Font(fntName, fntSize, FontStyle.Regular)
            txtOmschrijving.Font = fnt
            txtOmschrijving.ForeColor = _BodyTextForeColor

            If recType = PrintRecordType.Header Then
                Dim txt As String = txtOmschrijving.Value
                rptDetails.AddBookmark(Fields("Omschrijving").Value & "\" & txt.TrimEnd(":", ";"))
            End If

            If _NegativeRed Then
                txtSubTotaal.ForeColor = If(pIsNegative(Fields("Bedrag").Value), Color.Red, _BodyTextForeColor)
                txtRegelTotaal.ForeColor = txtSubTotaal.ForeColor
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub pResetFieldColors()
        For Each txtObj As Object In rptDetails.Controls ' reset
            If TypeOf txtObj Is TextBox Then
                txtObj.BackColor = Color.Transparent 'Nothing ' Color.White
                txtObj.ForeColor = _BodyTextForeColor
            End If
        Next
    End Sub

    Private Sub pMarkField(col As String)
        If _MarkeerCols.Contains(col) Then
            Dim naam As String = _MarkeerCols(col)
            Select Case naam
                Case "Omschrijving"
                    txtOmschrijving.BackColor = _MarkColor
                Case "Aantal"
                    txtAantal.BackColor = _MarkColor
                Case "Eenheid"
                    txtEenheid.BackColor = _MarkColor
                Case "Prijs"
                    txtPrijs.BackColor = _MarkColor
                Case "Stelpost"
                    txtStelpost.BackColor = _MarkColor
                Case "Onderaanneming"
                    txtOda.BackColor = _MarkColor
                Case "EenheidsKosten"
                    txtEhPrijs.BackColor = _MarkColor
                Case "Subtotaal"
                    txtSubTotaal.BackColor = _MarkColor
                Case "Totaal"
                    txtTotaal.BackColor = _MarkColor
                Case "Artnr."
                    txtArtNr.BackColor = _MarkColor
            End Select
        End If
    End Sub

    Private Sub pSetFieldColors(lstColors As String, useBackColor As Boolean, useForeColor As Boolean)
        Try
            lstColors = lstColors.Trim("|")
            If lstColors = "" Then Return
            Dim arCells As String() = lstColors.Split("|")
            For Each strCell As String In arCells
                Dim arCell As String() = strCell.Split(".")
                Dim col As String = arCell(0)
                If _MarkeerCols.Contains(col) Then
                    Dim naam As String = _MarkeerCols(col)
                    Dim arColors As String() = arCell(1).Split(";")
                    Dim kleur1 As Color = If(arColors(0) <> "0", Color.FromArgb(CInt(arColors(0))), Nothing)
                    Dim kleur2 As Color = If(arColors(1) <> "0", Color.FromArgb(CInt(arColors(1))), Color.Black) 'Color.FromArgb(CInt(arColors(1)))
                    Select Case naam
                        Case "Omschrijving"
                            If useBackColor Then txtOmschrijving.BackColor = kleur1
                            If useForeColor Then txtOmschrijving.ForeColor = kleur2
                        Case "Aantal"
                            If useBackColor Then txtAantal.BackColor = kleur1
                            If useForeColor Then txtAantal.ForeColor = kleur2
                        Case "Eenheid"
                            If useBackColor Then txtEenheid.BackColor = kleur1
                            If useForeColor Then txtEenheid.ForeColor = kleur2
                        Case "Artnr."
                            If useBackColor Then txtArtNr.BackColor = kleur1
                            If useForeColor Then txtArtNr.ForeColor = kleur2
                        Case "Prijs"
                            If useBackColor Then txtPrijs.BackColor = kleur1
                            If useForeColor Then txtPrijs.ForeColor = kleur2
                        Case "Subtotaal"
                            If useBackColor Then txtSubTotaal.BackColor = kleur1
                            If useForeColor Then txtSubTotaal.ForeColor = kleur2
                        Case "Totaal"
                            If useBackColor Then txtTotaal.BackColor = kleur1
                            If useForeColor Then txtTotaal.ForeColor = kleur2
                        Case "KostenEh"
                            If useBackColor Then txtEhPrijs.BackColor = kleur1
                            If useForeColor Then txtEhPrijs.ForeColor = kleur2
                    End Select
                End If
            Next
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ghTekst_Format(sender As Object, e As EventArgs) Handles ghTekst.Format
        If rtfVoorloopTekst.Text.Trim <> "" Then
            ghTekst.AddBookmark("Intro")
        End If
    End Sub

    Private Sub gfTekst_Format(sender As Object, e As EventArgs) Handles gfTekst.Format
        If rtfNaloopTekst.Text.Trim <> "" Then
            gfTekst.AddBookmark("Slot")
        End If
    End Sub

    Private Sub ghHoofdstuk_Format(sender As Object, e As EventArgs) Handles ghHoofdstuk.Format
        Dim bm As String = txtGroepsOmschrijving.Value
        ghHoofdstuk.AddBookmark(bm)
    End Sub

    Private Sub gfHoofdstuk_Format(sender As Object, e As EventArgs) Handles gfHoofdstuk.Format
        Try
            Dim totaal As Double = Fields("GroepTotaal").Value
            If _NegativeRed Then
                txtGroepTotaal.ForeColor = If(pIsNegative(totaal), Color.Red, _BodyTextForeColor)
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub ghTekstblok_Format(sender As Object, e As EventArgs) Handles ghTekstblok.Format
        Try
            If DataSource Is Nothing Then Return
            Dim fntStyle As FontStyle = Fields("LetterType").Value ' reset
            Dim fntSize As Single = txtOmschrijving.Font.Size
            Dim fntName As String = txtOmschrijving.Font.Name
            Dim fnt As Font = New Font(fntName, fntSize, fntStyle)
            txtTitel.Font = fnt
            If imgProduct.Image IsNot Nothing Then
                imgProduct.Height = imgProduct.Image.Height * imgProduct.Width / imgProduct.Image.Width
                If imgProduct.Height > imgProduct.Width Then
                    imgProduct.Height = imgProduct.Width
                End If
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub pSetOutputFormats()
        txtAantal.OutputFormat = "# ##0.00"
        txtPrijs.OutputFormat = "# ##0.00"
        txtEhPrijs.OutputFormat = "# ### ##0.00"
        txtSubTotaal.OutputFormat = "# ### ##0.00"
        txtRegelTotaal.OutputFormat = "# ### ##0.00"
        txtGroepTotaal.OutputFormat = "# ### ##0.00"
        txtTotaal.OutputFormat = "# ### ##0.00"
        txtTotaalexclBtw.OutputFormat = "# ### ##0.00"
        txtBtwHoog.OutputFormat = "# ### ##0.00"
        txtBtwLaag.OutputFormat = "# ### ##0.00"
        txtBtwVerlegd.OutputFormat = "# ### ##0.00"
        txtTotaalInclBtw.OutputFormat = "# ### ##0.00"
    End Sub

    Private Sub pSetColumnLines()
        Dim x As Single = ghLine1.X1
        Dim x2 As Single = ghLine1.X2
        Dim y As Single = ghLine1.Y1
        Dim clr As Color = ghLine1.LineColor

        Dim fntDefault As Font = New Font("Arial", 9.75!, FontStyle.Bold)
        Dim fnt As Font = txtGroepsOmschrijving.Font

        pAddColumnLine(x, y, clr)
        If _PrintArtikelNr AndAlso Not _PrintAantal Then
            pAddColumnLine(txtOmschrijving.Left, y, clr)
        End If
        If _PrintAantal Then
            If _PrintArtikelNr Then
                pAddColumnLine(txtAantal.Left, y, clr)
            End If
            pAddColumnLine(txtEenheid.Left, y, clr)
            pAddColumnLine(txtOmschrijving.Left, y, clr)
        End If
        If _PrintPrijs Then
            pAddColumnLine(txtEhPrijs.Left, y, clr)
        End If
        If _PrintParagraafTotalen AndAlso _PrintRegelTotalen OrElse _PrintPrijs Then
            pAddColumnLine(txtSubTotaal.Left, y, clr)
        End If
        pAddColumnLine(txtRegelTotaal.Left, y, clr)
        pAddColumnLine(x2, y, clr)

        gfLine1.LineColor = clr
        gfLine1.X1 = x
        gfLine1.X2 = x2
        gfLine1.Visible = True
        ghLine1.Visible = True ' voor de zekerheid
    End Sub

    Private Sub pAddColumnLine(x As Single, y As Single, clr As Color)
        Dim line1 As New CrossSectionLine
        line1.Start = New PointF(x, y)
        line1.End = New PointF(x, 0)
        line1.LineColor = clr
        ghHoofdstuk.Controls.Add(line1)
    End Sub

    Private Sub rptTester_PageEnd(sender As Object, e As EventArgs) Handles Me.PageEnd
        Console.WriteLine("Page-End > milliseconden: >>> " & _sw.ElapsedMilliseconds)
    End Sub

    Private _rtf As String = ""

    Private _rtf2 As String = ""
End Class
